var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { createComponent } from 'cf-style-container';
import PropTypes from 'prop-types';
import { Loading } from 'cf-component-loading';
import { Box } from 'cf-component-box';

var NoItems = createComponent(function () {
  return {
    margin: '0.7em'
  };
}, 'p');
NoItems.setDisplayName('NoItems');

var tableStyles = function tableStyles(_ref) {
  var theme = _ref.theme,
      loading = _ref.loading,
      fixedLayout = _ref.fixedLayout;
  return {
    display: 'table',
    borderCollapse: 'collapse',
    width: '100%',
    backgroundColor: theme.colors.white,
    tableLayout: fixedLayout ? 'fixed' : 'auto',
    cursor: 'pointer',
    pointerEvents: loading ? 'none' : 'auto'
  };
};

var StyledTable = createComponent(tableStyles, 'table');
StyledTable.setDisplayName('Table');

var NonTableWrapper = createComponent(function (_ref2) {
  var theme = _ref2.theme,
      loading = _ref2.loading;
  return {
    width: '100%',
    backgroundColor: theme.colors.white,
    cursor: 'pointer',
    pointerEvents: loading ? 'none' : 'auto'
  };
});
NonTableWrapper.setDisplayName('NonTableWrapper');

var Table = function (_React$Component) {
  _inherits(Table, _React$Component);

  function Table() {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this));

    _this.renderExtraContent = _this.renderExtraContent.bind(_this);
    return _this;
  }

  _createClass(Table, [{
    key: 'getChildContext',
    value: function getChildContext() {
      var _props = this.props,
          bordered = _props.bordered,
          loading = _props.loading,
          empty = _props.empty,
          errored = _props.errored,
          renderTableToDom = _props.renderTableToDom;

      return {
        bordered: bordered,
        loading: loading,
        errored: errored,
        empty: empty,
        renderTableToDom: renderTableToDom
      };
    }
  }, {
    key: 'renderExtraContent',
    value: function renderExtraContent() {
      var _props2 = this.props,
          loading = _props2.loading,
          errored = _props2.errored,
          empty = _props2.empty,
          searching = _props2.searching,
          noItemsNode = _props2.noItemsNode,
          noItemsMatchingSearchNode = _props2.noItemsMatchingSearchNode,
          errorNode = _props2.errorNode,
          translations = _props2.translations;


      if (errored) {
        return React.createElement(
          NoItems,
          null,
          errorNode || translations.error
        );
      }

      if (loading) {
        if (empty) {
          return loading && React.createElement(
            Box,
            { display: 'inline-flex', padding: '8px' },
            React.createElement(Loading, { size: '1.5x' }),
            ' ',
            React.createElement(
              Box,
              { marginLeft: '16px' },
              translations.loading
            )
          );
        }
      }

      if (empty) {
        if (searching) {
          return React.createElement(
            NoItems,
            null,
            noItemsMatchingSearchNode || translations.noItemsMatchingSearchTerm
          );
        }
        return React.createElement(
          NoItems,
          null,
          noItemsNode || translations.noItems
        );
      }

      return null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          children = _props3.children,
          loading = _props3.loading,
          renderTableToDom = _props3.renderTableToDom,
          fixedLayout = _props3.fixedLayout;
      // export default ({ loading, myProp }) => {
      //   return loading ? <div>'hello'</div> : <div>'not loading'</div>;
      // };

      return React.createElement(
        'div',
        null,
        renderTableToDom ? React.createElement(
          StyledTable,
          { loading: loading, fixedLayout: fixedLayout },
          children
        ) : React.createElement(
          NonTableWrapper,
          { loading: loading },
          ' ',
          children,
          ' '
        ),
        this.renderExtraContent()
      );
    }
  }]);

  return Table;
}(React.Component);

Table.displayName = 'Table';

Table.childContextTypes = {
  bordered: PropTypes.bool,
  loading: PropTypes.bool,
  errored: PropTypes.bool,
  empty: PropTypes.bool,
  renderTableToDom: PropTypes.bool
};

Table.propTypes = {
  className: PropTypes.string,
  children: PropTypes.node,
  bordered: PropTypes.bool,
  fixedLayout: PropTypes.bool,
  loading: PropTypes.bool,
  errored: PropTypes.bool,
  empty: PropTypes.bool,
  noItemsNode: PropTypes.node,
  noItemsMatchingSearchNode: PropTypes.node,
  errorNode: PropTypes.node,
  searching: PropTypes.bool,
  translations: PropTypes.object,
  renderTableToDom: PropTypes.bool //if true to render a table HTML element, otherwise a div
};

Table.defaultProps = {
  bordered: true,
  fixedLayout: true,
  loading: false,
  empty: false,
  searching: false,
  renderTableToDom: true, //by default render a table HTML element
  translations: {
    noItems: 'There are currently no records.',
    noItemsMatchingSearchTerm: "Hmm... We couldn't find any matching records",
    error: 'Looks like something went wrong... Please try again later.',
    loading: 'Loading'
  }
};

export default Table;