import React from 'react';
import { createComponent } from 'cf-style-container';
import PropTypes from 'prop-types';

var TBody = createComponent(function (_ref) {
  var transitionLoading = _ref.transitionLoading;
  return {
    display: 'table-row-group',
    opacity: transitionLoading ? 0.5 : undefined
  };
}, 'tbody');

TBody.setDisplayName('TBody');

TBody.propTypes = {
  transitionLoading: PropTypes.bool
};

var NonTableBodyWrapper = createComponent(function (_ref2) {
  var transitionLoading = _ref2.transitionLoading;
  return {
    opacity: transitionLoading ? 0.5 : undefined
  };
});
NonTableBodyWrapper.setDisplayName('NonTableBodyWrapper');
NonTableBodyWrapper.propTypes = {
  transitionLoading: PropTypes.bool
};

var TableBody = function TableBody(_ref3, _ref4) {
  var children = _ref3.children;
  var loading = _ref4.loading,
      empty = _ref4.empty,
      errored = _ref4.errored,
      renderTableToDom = _ref4.renderTableToDom;

  var transitionLoading = loading && !empty;
  return renderTableToDom ? React.createElement(
    TBody,
    { transitionLoading: transitionLoading },
    !empty && !errored && children
  ) : React.createElement(
    NonTableBodyWrapper,
    { transitionLoading: transitionLoading },
    !empty && !errored && children
  );
};

TableBody.propTypes = {
  children: PropTypes.node
};

TableBody.contextTypes = {
  loading: PropTypes.bool,
  errored: PropTypes.bool,
  empty: PropTypes.bool,
  renderTableToDom: PropTypes.bool
};

export default TableBody;