var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { createComponent } from 'cf-style-container';
import PropTypes from 'prop-types';

var tableCellStyles = function tableCellStyles(_ref) {
  var align = _ref.align,
      bordered = _ref.bordered,
      textEllipsis = _ref.textEllipsis,
      theme = _ref.theme,
      hover = _ref.hover,
      width = _ref.width,
      hideOnMobile = _ref.hideOnMobile;
  return {
    display: hideOnMobile ? 'none' : 'table-cell',
    lineHeight: '1.5',
    verticalAlign: 'middle',
    textAlign: align ? align : 'initial',
    width: width ? width : 'auto',
    whiteSpace: textEllipsis ? 'nowrap' : 'initial',
    overflow: textEllipsis ? 'hidden' : 'initial',
    borderLeft: bordered ? '1px solid ' + theme.colors.gray[7] : 'none',
    paddingTop: theme.space[2],
    paddingBottom: theme.space[2],
    paddingLeft: theme.space[3],
    paddingRight: theme.space[3],
    mobileWide: {
      display: 'table-cell'
    },
    textOverflow: textEllipsis ? 'ellipsis' : 'initial',
    '&:last-child': {
      borderRight: bordered ? '1px solid ' + theme.colors.gray[7] : 'none'
    },
    '&:hover': hover ? {
      backgroundColor: theme.colors.gray[6] + '!important',
      cursor: 'pointer'
    } : undefined
  };
};

var TableHeadCell = createComponent(tableCellStyles, 'th', ['colSpan', 'onClick']);
TableHeadCell.setDisplayName('TableHeadCell');

var TableRowCell = createComponent(tableCellStyles, 'td', ['colSpan', 'onClick']);
TableRowCell.setDisplayName('TableRowCell');

var TableCell = function (_React$Component) {
  _inherits(TableCell, _React$Component);

  function TableCell() {
    _classCallCheck(this, TableCell);

    return _possibleConstructorReturn(this, (TableCell.__proto__ || Object.getPrototypeOf(TableCell)).apply(this, arguments));
  }

  _createClass(TableCell, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          align = _props.align,
          children = _props.children,
          className = _props.className,
          colSpan = _props.colSpan,
          hideOnMobile = _props.hideOnMobile,
          hover = _props.hover,
          textEllipsis = _props.textEllipsis,
          width = _props.width,
          onClick = _props.onClick;
      var _context = this.context,
          bordered = _context.bordered,
          isHeader = _context.isHeader;


      return isHeader ? React.createElement(
        TableHeadCell,
        {
          align: align,
          bordered: bordered,
          className: className,
          colSpan: colSpan,
          hideOnMobile: hideOnMobile,
          hover: hover,
          textEllipsis: textEllipsis,
          width: width,
          onClick: onClick
        },
        children
      ) : React.createElement(
        TableRowCell,
        {
          align: align,
          bordered: bordered,
          className: className,
          colSpan: colSpan,
          hideOnMobile: hideOnMobile,
          hover: hover,
          textEllipsis: textEllipsis,
          width: width,
          onClick: onClick
        },
        children
      );
    }
  }]);

  return TableCell;
}(React.Component);

var CellPropTypes = {
  align: PropTypes.oneOf(['left', 'center', 'right']),
  children: PropTypes.node,
  className: PropTypes.string,
  colSpan: PropTypes.number,
  hideOnMobile: PropTypes.bool,
  hover: PropTypes.bool,
  textEllipsis: PropTypes.bool,
  width: PropTypes.string,
  onClick: PropTypes.func
};

TableHeadCell.propTypes = CellPropTypes;
TableRowCell.propTypes = CellPropTypes;

TableCell.contextTypes = {
  bordered: PropTypes.bool,
  isHeader: PropTypes.bool
};

TableCell.propTypes = CellPropTypes;

TableCell.defaultProps = {
  align: 'left',
  textEllipsis: false,
  hideOnMobile: false,
  hover: false
};

export default TableCell;