var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { createComponent } from 'cf-style-container';
import PropTypes from 'prop-types';
import colorPropTypes from './colorPropTypes';

var Row = createComponent(function (_ref) {
  var active = _ref.active,
      accent = _ref.accent,
      onClick = _ref.onClick,
      theme = _ref.theme,
      hover = _ref.hover,
      bordered = _ref.bordered,
      separator = _ref.separator;
  return {
    display: 'table-row',
    transition: 'background-color 100ms',
    borderBottom: bordered || separator ? '1px solid rgba(0,0,0,0.1)' : 'none',
    borderLeft: accent === 'none' ? undefined : '2px solid ' + theme.colors[accent],
    cursor: onClick ? 'pointer' : 'initial',
    backgroundColor: active ? theme.colors.gray[9] : undefined,
    '&:hover': hover ? {
      backgroundColor: theme.colors.gray[9] + '!important',
      cursor: 'pointer'
    } : undefined
  };
}, 'tr', ['onClick', 'data-test-id']);

Row.setDisplayName('Row');

Row.propTypes = {
  active: PropTypes.bool,
  onClick: PropTypes.func,
  hover: PropTypes.bool,
  bordered: PropTypes.bool
};

var TableRow = function (_React$Component) {
  _inherits(TableRow, _React$Component);

  function TableRow() {
    _classCallCheck(this, TableRow);

    return _possibleConstructorReturn(this, (TableRow.__proto__ || Object.getPrototypeOf(TableRow)).apply(this, arguments));
  }

  _createClass(TableRow, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          accent = _props.accent,
          active = _props.active,
          onClick = _props.onClick,
          children = _props.children,
          hover = _props.hover,
          separator = _props.separator,
          testId = _props.testId;
      var bordered = this.context.bordered;

      return React.createElement(
        Row,
        {
          active: active,
          accent: accent,
          onClick: onClick,
          bordered: bordered,
          hover: hover,
          separator: separator,
          'data-test-id': testId
        },
        children
      );
    }
  }]);

  return TableRow;
}(React.Component);

TableRow.contextTypes = {
  bordered: PropTypes.bool
};

TableRow.propTypes = {
  accent: colorPropTypes,
  active: PropTypes.bool,
  children: PropTypes.node,
  onClick: PropTypes.func,
  hover: PropTypes.bool,
  separator: PropTypes.bool,
  testId: PropTypes.string
};

TableRow.defaultProps = {
  hover: false,
  accent: 'none'
};
export default TableRow;