'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _cfStyleContainer = require('cf-style-container');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const TBody = (0, _cfStyleContainer.createComponent)(({ transitionLoading }) => ({
  display: 'table-row-group',
  opacity: transitionLoading ? 0.5 : undefined
}), 'tbody');

TBody.setDisplayName('TBody');

TBody.propTypes = {
  transitionLoading: _propTypes2.default.bool
};

const NonTableBodyWrapper = (0, _cfStyleContainer.createComponent)(({ transitionLoading }) => ({
  opacity: transitionLoading ? 0.5 : undefined
}));
NonTableBodyWrapper.setDisplayName('NonTableBodyWrapper');
NonTableBodyWrapper.propTypes = {
  transitionLoading: _propTypes2.default.bool
};

const TableBody = ({ children }, { loading, empty, errored, renderTableToDom }) => {
  const transitionLoading = loading && !empty;
  return renderTableToDom ? _react2.default.createElement(
    TBody,
    { transitionLoading: transitionLoading },
    !empty && !errored && children
  ) : _react2.default.createElement(
    NonTableBodyWrapper,
    { transitionLoading: transitionLoading },
    !empty && !errored && children
  );
};

TableBody.propTypes = {
  children: _propTypes2.default.node
};

TableBody.contextTypes = {
  loading: _propTypes2.default.bool,
  errored: _propTypes2.default.bool,
  empty: _propTypes2.default.bool,
  renderTableToDom: _propTypes2.default.bool
};

exports.default = TableBody;