'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _cfStyleContainer = require('cf-style-container');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const tableHeadStyles = ({ theme }) => ({
  display: 'table-header-group',
  backgroundColor: theme.colors.gray[7],
  fontWeight: theme.weightSemiBold
});

class TableHead extends _react2.default.Component {
  getChildContext() {
    return {
      isHeader: true
    };
  }

  render() {
    const { className, children } = this.props;
    return _react2.default.createElement(
      'thead',
      { className: className },
      children
    );
  }
}

TableHead.displayName = 'TableHead';

TableHead.childContextTypes = {
  isHeader: _propTypes2.default.bool
};

TableHead.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node
};

exports.default = (0, _cfStyleContainer.createComponent)(tableHeadStyles, TableHead);