'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _cfStyleContainer = require('cf-style-container');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _colorPropTypes = require('./colorPropTypes');

var _colorPropTypes2 = _interopRequireDefault(_colorPropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const Row = (0, _cfStyleContainer.createComponent)(({ active, accent, onClick, theme, hover, bordered, separator }) => ({
  display: 'table-row',
  transition: 'background-color 100ms',
  borderBottom: bordered || separator ? '1px solid rgba(0,0,0,0.1)' : 'none',
  borderLeft: accent === 'none' ? undefined : `2px solid ${theme.colors[accent]}`,
  cursor: onClick ? 'pointer' : 'initial',
  backgroundColor: active ? theme.colors.gray[9] : undefined,
  '&:hover': hover ? {
    backgroundColor: `${theme.colors.gray[9]}!important`,
    cursor: 'pointer'
  } : undefined
}), 'tr', ['onClick', 'data-test-id']);

Row.setDisplayName('Row');

Row.propTypes = {
  active: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  hover: _propTypes2.default.bool,
  bordered: _propTypes2.default.bool
};

class TableRow extends _react2.default.Component {
  render() {
    const {
      accent,
      active,
      onClick,
      children,
      hover,
      separator,
      testId
    } = this.props;
    const { bordered } = this.context;
    return _react2.default.createElement(
      Row,
      {
        active: active,
        accent: accent,
        onClick: onClick,
        bordered: bordered,
        hover: hover,
        separator: separator,
        'data-test-id': testId
      },
      children
    );
  }
}

TableRow.contextTypes = {
  bordered: _propTypes2.default.bool
};

TableRow.propTypes = {
  accent: _colorPropTypes2.default,
  active: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  onClick: _propTypes2.default.func,
  hover: _propTypes2.default.bool,
  separator: _propTypes2.default.bool,
  testId: _propTypes2.default.string
};

TableRow.defaultProps = {
  hover: false,
  accent: 'none'
};
exports.default = TableRow;